# Подробное описание использования команды <init>

init (синоним i) - инициализация нового хранилища git и наполнение его данными из хранилища 1С

> Подробную справку по опциям и аргументам см. `gitsync init --help`

--------------
### Справка по использованию команды:
```
Команда: init, i
 Инициализация структуры нового хранилища git. Подготовка к синхронизации

Строка запуска: gitsync init [ОПЦИИ] PATH [WORKDIR]

Аргументы:
  PATH          Путь к хранилищу конфигурации 1С. (env $GITSYNC_STORAGE_PATH)
  WORKDIR       Адрес локального репозитория GIT или каталог исходников внутри локальной копии git-репозитория. По умолчанию текущий каталог (env $GITSYNC_WORKDIR)

Опции:
  -u, --storage-user    пользователь хранилища конфигурации (env $GITSYNC_STORAGE_USER) (по умолчанию Администратор)
  -p, --storage-pwd     пароль пользователя хранилища конфигурации (env $GITSYNC_STORAGE_PASSWORD, $GITSYNC_STORAGE_PWD)
```
--------------
### Глобальные переменные окружения
| Имя                 | Описание                                               |
|---------------------|--------------------------------------------------------|
| `GITSYNC_V8VERSION` | маска версии платформы (8.3, 8.3.5, 8.3.6.2299 и т.п.) |
| `GITSYNC_VERBOSE`   | вывод отладочной информации в процессе выполнения      |
| `GITSYNC_TEMP`      | путь к каталогу временных файлов                       |
| `GITSYNC_EMAIL`     | домен почты для пользователей git                      |

--------------
### Переменные окружения команды

| Имя                        | Описание                                   |
|----------------------------|--------------------------------------------|
| `GITSYNC_WORKDIR`          | рабочий каталог для команды                |
| `GITSYNC_STORAGE_PATH`     | путь к хранилищу конфигурации 1С.          |
| `GITSYNC_STORAGE_USER`     | пользователь хранилища конфигурации        |
| `GITSYNC_STORAGE_PASSWORD` | пароль пользователя хранилища конфигурации |
--------------
### Значения по умолчанию:
|                    |                              |
|--------------------|------------------------------|
| WORKDIR            | текущая рабочая директория   |
| -u, --storage-user | пользователь `Администратор` |

--------------
## Примеры, использования
***
* Простое использование

    `gitsync init C:/Хранилище_1С/ C:/GIT/src`

    Данная команда создаст новый репозиторий git в каталоге `C:/GIT/src` из хранилища 1С по пути `C:/Хранилище_1С/`
***
* Указание конкретной версии платформы

    `gitsync --v8version=8.3.9 init C:/Хранилище_1С/ C:/GIT/src`

    Данная команда создаст новый репозиторий git в каталоге `C:/GIT/src` из хранилища 1С по пути `C:/Хранилище_1С/`
    Для работы будет использоваться платформа 8.3.9.xxxx
***
* Указание вывода отладочных логов

    `gitsync --verbose init C:/Хранилище_1С/ C:/GIT/src`
    или
    `gitsync -v init C:/Хранилище_1С/ C:/GIT/src`

    Данная команда создаст новый репозиторий git в каталоге `C:/GIT/src` из хранилища 1С по пути `C:/Хранилище_1С/`
    После указания будет выводиться дополнительные отладочные логи с признаком `Отладка`
***
* Указание каталога временных файлов при работе приложения

    `gitsync --tempdir=./temp_sync/ init C:/Хранилище_1С/ C:/GIT/src`
    или
    `gitsync -t ./temp_sync/ init C:/Хранилище_1С/ C:/GIT/src`

    Данная команда создаст новый репозиторий git в каталоге `C:/GIT/src` из хранилища 1С по пути `C:/Хранилище_1С/`
    Для работы будет использоваться каталог временных файлов `./temp_sync/`
***
* Инициализация в текущем рабочем каталоге,

    > переменная окружения **`GITSYNC_WORKDIR`** не должна быть задана

    ```sh
    cd C:/work_dir/
    gitsync init C:/Хранилище_1С/
    ```
    Данная команда создаст новый репозиторий git в каталоге `C:/work_dir/` из хранилища 1С по пути `C:/Хранилище_1С/`
***
* Инициализация в с указанием пользователя и пароля.

    ```sh
    gitsync init --storage-user Admin --storage-pwd=Secret C:/Хранилище_1С/ C:/work_dir/
    ```
    Данная команда создаст новый репозиторий git в каталоге `C:/work_dir/` из хранилища 1С по пути `C:/Хранилище_1С/`
***
* Использование синонимов (короткая версия предыдущего примера)

    ```sh
    gitsync i -uAdmin -p=Secret C:/Хранилище_1С/ C:/work_dir/
    ```
    Данная команда создаст новый репозиторий git в каталоге `C:/work_dir/` из хранилища 1С по пути `C:/Хранилище_1С/`
***
* Использование только переменных окружения

    linux:
    ```sh
    export GITSYNC_WORKDIR=./work_dir/
    export GITSYNC_STORAGE_PATH=./Хранилище_1С/

    export GITSYNC_STORAGE_USER=Админ
    export GITSYNC_STORAGE_PASSWORD=Пароль
    export GITSYNC_V8VERSION=8.3.7
    export GITSYNC_VERBOSE=true #Можно использовать Да/Ложь/Нет/Истина
    export GITSYNC_TEMP=./temp/sync
    gitsync i
    ```
    
    windows:
    ```cmd
    set GITSYNC_WORKDIR=./work_dir/
    set GITSYNC_STORAGE_PATH=./Хранилище_1С/

    set GITSYNC_STORAGE_USER=Админ
    set GITSYNC_STORAGE_PASSWORD=Пароль
    set GITSYNC_V8VERSION=8.3.7
    set GITSYNC_VERBOSE=true #Можно использовать Да/Ложь/Нет/Истина
    set GITSYNC_TEMP=./temp/sync

    gitsync i
    ```
    Данная команда создаст новый репозиторий git в каталоге `C:/work_dir/` из хранилища 1С по пути `C:/Хранилище_1С/`