﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;

	ВсеШаги = Новый Массив;

	ВсеШаги.Добавить("УстановилКаталогПроектаКакТекущий");
	ВсеШаги.Добавить("ВЛог_ФайлеЗапускаПродуктаЕстьСтрока");
	ВсеШаги.Добавить("ВЛог_ФайлеЗапускаПродуктаОтсутствуетСтрока");

	Возврат ВсеШаги;
КонецФункции


// Реализация шагов

//установил каталог проекта "tests/fixtures" как текущий
Процедура УстановилКаталогПроектаКакТекущий(Знач ПутьКаталога) Экспорт
	УстановитьТекущийКаталог(ОбъединитьПути(КаталогПроекта(), ПутьКаталога));
КонецПроцедуры

//в лог-файле запуска продукта есть строка "ЯЗапускаюПадающийШагСПараметром-Первый падающий шаг"
Процедура ВЛог_ФайлеЗапускаПродуктаЕстьСтрока(Знач ПроверяемаяСтрока) Экспорт
	ТекстЛогФайла = БДД.ПолучитьИзКонтекста("ТекстЛогФайлаПродукта");
	Ожидаем.Что(ТекстЛогФайла).Содержит(ПроверяемаяСтрока);
КонецПроцедуры

//в лог-файле запуска продукта отсутствует строка "ДоЭтогоШагаВыполнениеДойтиНеДолжно"
Процедура ВЛог_ФайлеЗапускаПродуктаОтсутствуетСтрока(Знач ПроверяемаяСтрока) Экспорт
	ТекстЛогФайла = БДД.ПолучитьИзКонтекста("ТекстЛогФайлаПродукта");
	Ожидаем.Что(ТекстЛогФайла).ЭтоНе().Содержит(ПроверяемаяСтрока);
КонецПроцедуры

Функция КаталогПроекта() Экспорт
	КаталогПроекта = ОбъединитьПути(ТекущийСценарий().Каталог, "..", "..", "..");
	Возврат КаталогПроекта;
КонецФункции
