# language: ru

Функционал: Таблицы данных
	Как Разработчик
	Я Хочу чтобы в ячейках таблицы данных автоматически распознавались различные типы значений

Сценарий: Проверяю передачу простой таблицы

  Когда я передаю таблицу
    | Ячейка11       | Ячейка12|
   | Ячейка21 | Ячейка22|
  Тогда переданная таблица является типом "ТаблицаЗначений"
  И у переданной таблицы 2 колонки
  И у переданной таблицы 2 строки
  И у 0 строки таблицы заданы значения "Ячейка11" и "Ячейка12"
  И у 1 строки таблицы заданы значения "Ячейка21" и "Ячейка22"

Сценарий: Разные типы в ячейках таблицы

  Когда я передаю таблицу
    | Ячейка11       | 11 |
    | Ячейка11       | 01.01.2020 |
   | Ячейка21 | 11,12 |
   | Ячейка21 | 01.01.20 |
  Тогда переданная таблица является типом "ТаблицаЗначений"
  И у переданной таблицы 2 колонки
  И у переданной таблицы 4 строки
  И у 0 строки таблицы заданы значения "Ячейка11" и 11
  И у 1 строки таблицы заданы значения "Ячейка11" и 01.01.2020
  И у 2 строки таблицы заданы значения "Ячейка21" и 11,12
  И у 3 строки таблицы заданы значения "Ячейка21" и 01.01.20

Сценарий: Дата в ячейке таблицы
  Когда я передаю таблицу
    | 29.11.2020 |

  Тогда в таблице в ячейке "0:0" значение имеет тип "Дата"
  И в таблице в ячейке "0:0" указано значение 29.11.2020


Сценарий: Числовое значение в ячейке
  Когда я передаю таблицу
    | 00000001   |
    | 1234567890 |

  Тогда в таблице в ячейке "0:0" значение имеет тип "Число"
  И в таблице в ячейке "0:0" указано значение 1

  Тогда в таблице в ячейке "1:0" значение имеет тип "Число"
  И в таблице в ячейке "1:0" указано значение 1234567890


Сценарий: Строка с литералом даты в ячейке таблицы
  Когда я передаю таблицу
    | Строка с датой внутри: 21.11.2020 |

  Тогда в таблице в ячейке "0:0" значение имеет тип "Строка"
  и в таблице в ячейке "0:0" указано значение "Строка с датой внутри: 21.11.2020"

Сценарий: Строка с числовым литералом в ячейке таблицы
  Когда я передаю таблицу
    | Строка 1 |

  Тогда в таблице в ячейке "0:0" значение имеет тип "Строка"
  И в таблице в ячейке "0:0" указано значение "Строка 1"
