
#Использовать logos

Перем Лог;
Перем ИндексКоллекция; // Соответствие
Перем ИндексСформирован; // Булево
Перем КоллекцияИндекса; // Произвольный

Функция Коллекция(Знач ВходящаяКоллекция) Экспорт
	
	КоллекцияИндекса = ВходящаяКоллекция;
	ИндексСформирован = Ложь;
	
	Возврат ЭтотОбъект;

КонецФункции

Процедура Очистить() Экспорт
	
	КоллекцияИндекса = Неопределено;
	ИндексСформирован = Ложь;

КонецПроцедуры

Функция ПолучитьИндекс() Экспорт

	ПроверитьИндекс();
	
	Возврат ИндексКоллекция;
	
КонецФункции

Функция Значение(Знач КлючИндекса) Экспорт

	ПроверитьИндекс();
	
	ЗначениеИзИндекса = ИндексКоллекция[КлючИндекса];

	Возврат ЗначениеИзИндекса;
	
КонецФункции

Процедура СформироватьИндекс()
	
	ИндексКоллекция = Новый Соответствие;

	// Рекурсивный вызов для входящих параметров
	ДобавитьЗначениеПараметра("", КоллекцияИндекса);

КонецПроцедуры

Процедура ПроверитьИндекс()

	Если КоллекцияИндекса = Неопределено Тогда
		ВызватьИсключение Новый ИнформацияОбОшибке("Коллекция индекса не установлена");
	КонецЕсли;

	Если НЕ ИндексСформирован Тогда
		СформироватьИндекс();
	КонецЕсли;
	
КонецПроцедуры

Функция ЭтоМассив(Знач Значение)
	Возврат ТипЗнч(Значение) = Тип("Массив");
КонецФункции

Функция ЭтоСоответствие(Знач Значение)
	Возврат ТипЗнч(Значение) = Тип("Соответствие");
КонецФункции

Функция ЭтоСтруктура(Знач Значение)
	Возврат ТипЗнч(Значение) = Тип("Структура");
КонецФункции

Функция ЭтоОбъект(Знач Значение)
	Возврат ТипЗнч(Значение) = Тип("Сценарий");
КонецФункции

Процедура ДобавитьПараметрВИндекс(Знач ИмяПараметра, Знач ЗначениеПараметра)

	// Вставляем все значение целиком
	Если Не ПустаяСтрока(ИмяПараметра) Тогда
		Лог.Отладка("Добавляю параметр <%1> со значением <%2> в индекс", ИмяПараметра, ЗначениеПараметра);
		ИндексКоллекция.Вставить(ИмяПараметра, ЗначениеПараметра);
	КонецЕсли;

	// Рекурсивное заполнение значения параметра
	ДобавитьЗначениеПараметра(ИмяПараметра, ЗначениеПараметра);

КонецПроцедуры

Процедура ДобавитьЗначениеПараметра(Знач ИмяПараметра, Знач ЗначениеПараметра)

	Если ЭтоМассив(ЗначениеПараметра) Тогда
		ДобавитьПараметрМассивВИндекс(ЗначениеПараметра, ИмяПараметра);
	ИначеЕсли ЭтоСоответствие(ЗначениеПараметра) Тогда
		ДобавитьСоответствиеВИндекс(ЗначениеПараметра, ИмяПараметра);
	ИначеЕсли ЭтоСтруктура(ЗначениеПараметра) Тогда
		ДобавитьСоответствиеВИндекс(ЗначениеПараметра, ИмяПараметра);
	КонецЕсли;

КонецПроцедуры

Процедура ДобавитьПараметрМассивВИндекс(Знач МассивЗначений, Знач ИмяРодителя = "")

	Лог.Отладка("Обрабатываю массив значений <%1> ", ИмяРодителя);

	ШаблонИмениПараметра = "%1";

	Если Не ПустаяСтрока(ИмяРодителя) Тогда
		ШаблонИмениПараметра = ИмяРодителя + ".%1";
	КонецЕсли;

	Для ИндексЗначения = 0 По МассивЗначений.ВГраница() Цикл

		ИмяПараметра = СтрШаблон(ШаблонИмениПараметра, ИндексЗначения);
		ДобавитьПараметрВИндекс(ИмяПараметра, МассивЗначений[ИндексЗначения]);

	КонецЦикла;

КонецПроцедуры

Процедура ДобавитьСоответствиеВИндекс(Знач ВходящиеПараметры, Знач ИмяРодителя = "")

	Лог.Отладка("Обрабатываю соответствие значений <%1> ", ИмяРодителя);

	ШаблонИмениПараметра = "%1";

	Если Не ПустаяСтрока(ИмяРодителя) Тогда
		ШаблонИмениПараметра = ИмяРодителя + ".%1";
	КонецЕсли;

	Для каждого КлючЗначение Из ВходящиеПараметры Цикл

		Лог.Отладка("Обрабатываю соответствие ключ <%1> ", КлючЗначение.Ключ);

		ИмяПараметра = СтрШаблон(ШаблонИмениПараметра, КлючЗначение.Ключ);
		ЗначениеПараметра = КлючЗначение.Значение;

		ДобавитьПараметрВИндекс(ИмяПараметра, ЗначениеПараметра);

	КонецЦикла;

КонецПроцедуры

Лог = Логирование.ПолучитьЛог("oscript.lib.configor.index");
