﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd

#Использовать asserts
#Использовать tempfiles

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;

	ВсеШаги = Новый Массив;

	ВсеШаги.Добавить("ЯСоздаюВременныйФайлВоВременномКаталогеИСохраняюЕгоВКонтекст");
	ВсеШаги.Добавить("ЯДобавляюВременныйФайлВИндекс");
	ВсеШаги.Добавить("ЯДобавляюВременныйКаталогВИндекс");

	Возврат ВсеШаги;
КонецФункции

// Реализация шагов

// Процедура выполняется перед запуском каждого сценария
Процедура ПередЗапускомСценария(Знач Узел) Экспорт
	
КонецПроцедуры

// Процедура выполняется после завершения каждого сценария
Процедура ПослеЗапускаСценария(Знач Узел) Экспорт

КонецПроцедуры

//Я создаю временный файл во "temp.tmp" временном каталоге и сохраняю его в контекст
Процедура ЯСоздаюВременныйФайлВоВременномКаталогеИСохраняюЕгоВКонтекст(ИмяФайла) Экспорт
	ВременныйКаталог = БДД.ПолучитьИзКонтекста("ВременныйКаталог");
	ВременныйФайл = ОбъединитьПути(ВременныйКаталог, ИмяФайла);
	ЗаписьФайла = Новый ЗаписьТекста(ВременныйФайл);
	ЗаписьФайла.Закрыть();
	БДД.СохранитьВКонтекст("ВременныйФайл", ВременныйФайл);
КонецПроцедуры

//Я добавляю временный файл в индекс
Процедура ЯДобавляюВременныйФайлВИндекс() Экспорт
	ВременныйФайл = БДД.ПолучитьИзКонтекста("ВременныйФайл");
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.ДобавитьФайлВИндекс(ВременныйФайл);
КонецПроцедуры

//Я добавляю временный каталог в индекс
Процедура ЯДобавляюВременныйКаталогВИндекс() Экспорт
	ВременныйКаталог = БДД.ПолучитьИзКонтекста("ВременныйКаталог");
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.ДобавитьФайлВИндекс(ВременныйКаталог);
КонецПроцедуры
