﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;

	ВсеШаги = Новый Массив;

	ВсеШаги.Добавить("ЯУстанавливаюРабочийКаталогВоВременныйКаталог");
	ВсеШаги.Добавить("ЯКлонируюУдаленныйРепозиторийВПодкаталог");
	ВсеШаги.Добавить("ЯУстанавливаюРабочийКаталогВСклонированныйРепозиторий");

	Возврат ВсеШаги;
КонецФункции

// Реализация шагов

// Процедура выполняется перед запуском каждого сценария
Процедура ПередЗапускомСценария(Знач Узел) Экспорт
	
КонецПроцедуры

// Процедура выполняется после завершения каждого сценария
Процедура ПослеЗапускаСценария(Знач Узел) Экспорт
	
КонецПроцедуры

//Я устанавливаю рабочий каталог во временный каталог
Процедура ЯУстанавливаюРабочийКаталогВоВременныйКаталог() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ВременныйКаталог = БДД.ПолучитьИзКонтекста("ВременныйКаталог");
	ГитРепозиторий.УстановитьРабочийКаталог(ВременныйКаталог);
КонецПроцедуры

//Я устанавливаю рабочий каталог в склонированный репозиторий
Процедура ЯУстанавливаюРабочийКаталогВСклонированныйРепозиторий() Экспорт
	КаталогСклонированногоРепозитория = БДД.ПолучитьИзКонтекста("КаталогСклонированногоРепозитория");
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.УстановитьРабочийКаталог(КаталогСклонированногоРепозитория);
КонецПроцедуры

//Я клонирую удаленный репозиторий "https://github.com/nixel2007/gitrunner" в подкаталог "./gitrunner"
Процедура ЯКлонируюУдаленныйРепозиторийВПодкаталог(Знач ПутьУдаленномуРепозиторию, Знач ИмяКаталога) Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.КлонироватьРепозиторий(ПутьУдаленномуРепозиторию, ИмяКаталога);

	КаталогСклонированногоРепозитория = Новый Файл(ОбъединитьПути(ГитРепозиторий.ПолучитьРабочийКаталог(), ИмяКаталога));
	БДД.СохранитьВКонтекст("КаталогСклонированногоРепозитория", КаталогСклонированногоРепозитория.ПолноеИмя);
КонецПроцедуры


