﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd

#Использовать tempfiles

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;
	
	ВсеШаги = Новый Массив;
	
	ВсеШаги.Добавить("ЯФиксируюИзмененияССообщением");
	ВсеШаги.Добавить("ЯФиксируюИзмененияССообщениемСУказаниемАвтораИДатойАвтора");
	ВсеШаги.Добавить("ЯФиксируюИзмененияССообщениемСУказаниемКоммитераИДатойКоммита");
	
	Возврат ВсеШаги;
КонецФункции

// Реализация шагов

// Процедура выполняется перед запуском каждого сценария
Процедура ПередЗапускомСценария(Знач Узел) Экспорт
	
КонецПроцедуры

// Процедура выполняется после завершения каждого сценария
Процедура ПослеЗапускаСценария(Знач Узел) Экспорт
	
КонецПроцедуры

//Я фиксирую изменения с сообщением "Добавлен тестовый файл"
Процедура ЯФиксируюИзмененияССообщением(Знач ТекстСообщения) Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.Закоммитить(ТекстСообщения);
КонецПроцедуры

//Я фиксирую изменения с сообщением "Добавлен тестовый файл" с указанием автора "Другой автор" и датой автора 01.01.2016
Процедура ЯФиксируюИзмененияССообщениемСУказаниемАвтораИДатойАвтора(
	Знач ТекстСообщения, 
	Знач Автор, 
	Знач ДатаАвтора) Экспорт
	
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.Закоммитить(ТекстСообщения, , , Автор, ДатаАвтора);
КонецПроцедуры

//Я фиксирую изменения с сообщением "Добавлен тестовый файл" с указанием коммитера "Другой коммитер <1@1.ru>" и датой коммита 01.01.2016
Процедура ЯФиксируюИзмененияССообщениемСУказаниемКоммитераИДатойКоммита(Знач ТекстСообщения, Знач Коммитер, Знач ДатаКоммитера) Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.Закоммитить(ТекстСообщения, , , , , Коммитер, ДатаКоммитера);
КонецПроцедуры
	