# language: ru

Функциональность: Отправка изменений

Как разработчик
Я хочу иметь возможность отправлять изменения в удаленный репозиторий
Чтобы мочь автоматизировать больше рутинных действий на OneScript

Контекст:
    Допустим Я создаю новый объект ГитРепозиторий
    И Я создаю временный каталог и сохраняю его в контекст
    И Я инициализирую bare репозиторий во временном каталоге
    И Я сохраняю значение временного каталога в переменной "ВнешийРепозиторий"    
    И Я создаю новый объект ГитРепозиторий
    И Я создаю временный каталог и сохраняю его в контекст
    И Я инициализирую репозиторий во временном каталоге

Сценарий: Отправка зафиксированных изменений
    Допустим Я добавляю внешний репозиторий "origin" по сохраненному адресу внешнего репозитория
    И Я перехожу на ветку "test" с ее созданием
    И Я создаю временный файл "temp.tmp" во временном каталоге и сохраняю его в контекст
    И Я добавляю временный файл в индекс
    И Я фиксирую изменения с сообщением "Добавлен тестовый файл"
    Когда Я отправляю изменения во внешний репозиторий "origin" в ветку "test"
    И Я выполняю произвольную команду git "branch -a"
    Тогда Вывод команды содержит "remotes/origin/test"
    И Я выполняю произвольную команду git "push origin :test"

Сценарий: Отправка всех зафиксированных изменений через настройку отправки
    Допустим Я добавляю внешний репозиторий "origin" по сохраненному адресу внешнего репозитория
    И Я перехожу на ветку "test" с ее созданием
    И Я создаю временный файл "temp.tmp" во временном каталоге и сохраняю его в контекст
    И Я добавляю временный файл в индекс
    И Я фиксирую изменения с сообщением "Добавлен тестовый файл"
    И Я создаю новый объект НастройкаКомандыОтправить
    И Я устанавливаю настройку отправки режима тишины
    И Я устанавливаю настройку отправки полная отправка
    И Я устанавливаю настройку отправки отображение прогресса
    И Я устанавливаю настройку режима отправки
    Когда Я отправляю изменения
    И Я выполняю произвольную команду git "branch -a"
    Тогда Вывод команды содержит "remotes/origin/test"
    И Я создаю новый объект НастройкаКомандыОтправить
    И Я устанавливаю настройку отправки произвольный заголовок "origin :test"
    И Я устанавливаю настройку режима отправки
    И Я отправляю изменения

Сценарий: Отправка зафиксированных изменений через настройку отправки в отдельное пространство
    Допустим Я добавляю внешний репозиторий "origin" по сохраненному адресу внешнего репозитория
    И Я перехожу на ветку "test" с ее созданием
    И Я создаю временный файл "temp.tmp" во временном каталоге и сохраняю его в контекст
    И Я добавляю временный файл в индекс
    И Я фиксирую изменения с сообщением "Добавлен тестовый файл"
    И Я создаю новый объект НастройкаКомандыОтправить
    И Я устанавливаю репозиторий отправки "origin"
    И Я добавляю заголовок отправки из "refs/heads/test" в "refs/heads/my/test"
    И Я устанавливаю настройку режима отправки
    Когда Я отправляю изменения
    И Я выполняю произвольную команду git "branch -a"
    Тогда Вывод команды содержит "remotes/origin/my/test"
    И Я создаю новый объект НастройкаКомандыОтправить
    И Я устанавливаю репозиторий отправки "origin"
    И Я добавляю заголовок отправки из "" в "refs/heads/my/test"
    И Я устанавливаю настройку режима отправки
    И Я отправляю изменения
