# language: ru

Функциональность: Выполнение команды

Как разработчик
Я хочу иметь возможность выполнять команды
Чтобы я мог проще автоматизировать больше действий на OneScript

Контекст: Отключение отладки в логах
    Допустим Я выключаю отладку лога с именем "oscript.lib.commands"
    И Я очищаю параметры команды "git" в контексте
    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Выполнение команды без параметров
    Когда Я выполняю команду "git"
    Тогда Вывод команды "git" содержит "[--version]"
    И Код возврата команды "git" равен 1

Сценарий: Выполнение команды с параметрами
    Когда Я добавляю параметр "--version" для команды "git"
    И Я выполняю команду "git"
    Тогда Я сообщаю вывод команды "git"
    И Вывод команды "git" содержит "version"
    И Код возврата команды "git" равен 0

Сценарий: Выполнение команды с массивом параметров
    Когда Я добавляю параметры для команды "oscript"
    | -version |
    | -encoding=utf-8 |
    И Я выполняю команду "oscript"
    Тогда я вижу в консоли строку подобно "(\d+\.){3}\d+"

Сценарий: Выполнение команды через командный процессор системы
    Когда Я выполняю команду "oscript" через командный процессор системы
    Тогда Вывод команды "oscript" содержит "1Script Execution Engine"
    И Код возврата команды "oscript" равен 0

Сценарий: Выполнение команды без командного процессора системы
    Когда Я выполняю команду "oscript" без командного процессора системы
    Тогда Вывод команды "oscript" содержит "1Script Execution Engine"
    И Код возврата команды "oscript" равен 0

Сценарий: Проверка правильного кода возврата команды
    Когда Я устанавливаю ожидаемый код возврата 0 для команды "oscript"
    Когда Я выполняю команду "oscript"
    Тогда Код возврата команды "oscript" равен 0

Сценарий: Проверка неправильного кода возврата команды
    Когда Я устанавливаю ожидаемый код возврата 123 для команды "oscript"
    Тогда Я получаю исключение при выполнении команды "oscript"
    И Код возврата команды "oscript" равен 0

Сценарий: Проверка правильного диапазона кодов возврата команды
    Когда Я устанавливаю ожидаемый диапазон кодов возврата от 0 до 10 для команды "oscript"
    Когда Я выполняю команду "oscript"
    Тогда Код возврата команды "oscript" равен 0

Сценарий: Выполнение команды c установленным периодом опроса завершения команды
    Когда Я устанавливаю период опроса завершения команды "oscript" в 1 миллисекунду
    И Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит "1Script Execution Engine"
    И Код возврата команды "oscript" равен 0

Сценарий: Выполнение команды c запретом немедленного вывода команды команды
    Когда Я снимаю флаг показа немедленного вывода команды "oscript"
    И Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит "1Script Execution Engine"
    И Код возврата команды "oscript" равен 0

Сценарий: Проверка неправильного диапазона кодов возврата команды
    Когда Я устанавливаю ожидаемый диапазон кодов возврата от 1 до 10 для команды "oscript"
    Тогда Я получаю исключение при выполнении команды "oscript"
    И Код возврата команды "oscript" равен 0

Сценарий: Выполнение команды с выводом в отдельный лог
    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я установил рабочий каталог как текущий каталог
    
    Допустим Я подключаю вывод команды "oscript" в лог "ТестовыйЛог"
    И Я подключаю вывод в файл "лог1.Log" для лога "ТестовыйЛог"
    И Я добавляю параметр "-version" для команды "oscript"
    
    Когда Я выполняю команду "oscript"
    Тогда я не вижу в консоли строку подобно "(\d+\.){3}\d+"
    Тогда я не вижу в консоли вывод "ФИЧА ВыполнениеКоманды"
    И Код возврата команды "oscript" равен 0
    И Я закрываю лог "ТестовыйЛог"
    И Файл "лог1.Log" содержит "ФИЧА ВыполнениеКоманды"

Сценарий: Выполнение команды с выводом в отдельные логи
    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я установил рабочий каталог как текущий каталог

    Допустим Я подключаю вывод команды "oscript" в лог "ТестовыйЛог"
    И Я подключаю вывод в файл "лог1.Log" для лога "ТестовыйЛог"
    И Я подключаю вывод в файл "лог2.txt" для лога "ТестовыйЛог2"
    Допустим Я подключаю вывод команды "oscript" в лог "ТестовыйЛог2"
    И Я добавляю параметр "-version" для команды "oscript"
    
    Когда Я выполняю команду "oscript"
    Тогда я не вижу в консоли строку подобно "(\d+\.){3}\d+"
    Тогда я не вижу в консоли вывод "ФИЧА ВыполнениеКоманды"
    И Код возврата команды "oscript" равен 0
    И Я закрываю лог "ТестовыйЛог"
    И Я закрываю лог "ТестовыйЛог2"
    И Файл "лог1.Log" содержит "ФИЧА ВыполнениеКоманды"
    И Файл "лог2.txt" содержит "ФИЧА ВыполнениеКоманды"

Сценарий: Выполнение команды с выводом в отдельный лог при включенном немедленном выводом команды
    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я установил рабочий каталог как текущий каталог

    Допустим Я устанавливаю флаг показа немедленного вывода команды "oscript"
    Допустим Я подключаю вывод команды "oscript" в лог "ТестовыйЛог"
    И Я подключаю вывод в файл "лог1.Log" для лога "ТестовыйЛог"
    И Я добавляю параметр "-version" для команды "oscript"
    
    Когда Я выполняю команду "oscript"
    Тогда я не вижу в консоли строку подобно "(\d+\.){3}\d+"
    Тогда я не вижу в консоли вывод "ФИЧА ВыполнениеКоманды"
    И Код возврата команды "oscript" равен 0
    И Я закрываю лог "ТестовыйЛог"

    И Файл "лог1.Log" содержит "ФИЧА ВыполнениеКоманды"
