#Использовать notify

#Использовать "../internal"

// Создать ПроцессорКоллекций на основании переданной коллекции.
//
// Параметры:
//   Коллекция - Произвольный - Коллекция (Массив, ТаблицаЗначений...), на основании которой нужно
//		сформировать ПроцессорКоллекций.
//
//  Возвращаемое значение:
//   ПроцессорКоллекций - Инстанс класса ПроцессорКоллекций, заполненный переданной коллекцией.
//
Функция ИзКоллекции(Коллекция) Экспорт
	ПроцессорКоллекций = Новый ПроцессорКоллекций();
	ПроцессорКоллекций.УстановитьКоллекцию(Коллекция);

	Возврат ПроцессорКоллекций;
КонецФункции

// Создать ПроцессорКоллекций на основании переданной строки.
// Переданная строка преобразуется в коллекцию путем разделения строк.
//
// Параметры:
//   Строка - Строка - Строка, на основании которой нужно сформировать ПроцессорКоллекций.
//   РазделительСтрок - Строка - Разделитель строк, применяемый к Строке для получения коллекции.
//		Если не передан, строка разделяется на элементы посимвольно.
//   ВключатьПустые - Булево - Указывает необходимость включать в коллекцию пустые строки,
//		которые могут образоваться в результате разделения исходной строки.
//
//  Возвращаемое значение:
//   ПроцессорКоллекций - Инстанс класса ПроцессорКоллекций.
//
Функция ИзСтроки(Строка, РазделительСтрок = Неопределено, ВключатьПустые = Истина) Экспорт

	Если РазделительСтрок = Неопределено Тогда
		Коллекция = Новый Массив;
		ДлинаСтроки = СтрДлина(Строка);
		Для сч = 1 По ДлинаСтроки Цикл
			Коллекция.Добавить(Сред(Строка, сч, 1));
		КонецЦикла;
	Иначе
		Коллекция = СтрРазделить(Строка, РазделительСтрок, ВключатьПустые);
	КонецЕсли;

	ПроцессорКоллекций = Новый ПроцессорКоллекций();
	ПроцессорКоллекций.УстановитьКоллекцию(Коллекция);
	
	Возврат ПроцессорКоллекций;
	
КонецФункции

// Стандартная функция сравнения.
// Сравнивает значения элементов коллекции через операторы ">", "<" и "=".
//
//  Возвращаемое значение:
//   ОписаниеОповещения - Инстанс класса ОписаниеОповещения, указывающий на стандартную функцию сравнения.
//
Функция СтандартнаяФункцияСравнения() Экспорт
	ДополнительныеПараметры = Новый Структура;
	ДополнительныеПараметры.Вставить("Элемент1");
	ДополнительныеПараметры.Вставить("Элемент2");
	
	ФункцияСравнения = Новый ОписаниеОповещения("ФункцияСравнения", ПроцессорыКоллекцийСлужебный, ДополнительныеПараметры);
	Возврат ФункцияСравнения;
КонецФункции

// Стандартная функция обработки - "Сообщить".
// Выполняет процедуру "Сообщить()" над каждым элементом коллекции.
//
//  Возвращаемое значение:
//   ОписаниеОповещения - Инстанс класса ОписаниеОповещения, указывающий на стандартную функцию обработки.
//
Функция СтандартнаяФункцияОбработки_Сообщить() Экспорт
	ФункцияОбработки = Новый ОписаниеОповещения("ФункцияОбработки_Сообщить", ПроцессорыКоллекцийСлужебный);
	Возврат ФункцияОбработки;
КонецФункции
