///////////////////////////////////////////////////////////////////////////////////////////////////
// Прикладной интерфейс

Процедура ОписаниеКоманды(Знач КомандаПриложения) Экспорт
	
	КомандаПриложения.Опция("q quiet", Ложь, """Тихий"" режим вывода без лишних сообщений.");
	КомандаПриложения.Опция("r remote", Ложь, "Вывести список пакетов в хабе");
	// КомандаПриложения.Опция("a all", Ложь, "Вывести список всех пакетов установленных и доступных в хабе");

КонецПроцедуры

Процедура ВыполнитьКоманду(Знач КомандаПриложения) Экспорт
	
	ТихийРежим = КомандаПриложения.ЗначениеОпции("quiet");
	ВыводПакетовНаХабе = КомандаПриложения.ЗначениеОпции("remote");
	
	Если ВыводПакетовНаХабе Тогда
		ТекстСообщения  = СтрШаблон("Пакеты в хабе:");		
		МенеджерПолучения = Новый МенеджерПолученияПакетов();
		УстановленныеПакеты = МенеджерПолучения.ПолучитьДоступныеПакеты();
	Иначе	
		
		ПутьККаталогуПакетов = ПолучитьЗначениеСистемнойНастройки("lib.system");
		ТекстСообщения = СтрШаблон("Пакеты в системном каталоге библиотек <%1>:", ПутьККаталогуПакетов);		
		
		КэшУстановленныхПакетов = Новый КэшУстановленныхПакетов(ПутьККаталогуПакетов);
		УстановленныеПакеты = КэшУстановленныхПакетов.ПолучитьУстановленныеПакеты();
	КонецЕсли;
	
	Если НЕ ТихийРежим Тогда
		Сообщить(ТекстСообщения);
	КонецЕсли;
	
	Для Каждого УстановленныйПакет Из УстановленныеПакеты Цикл
		СтрокаСообщения = УстановленныйПакет.Ключ;
		Если ТипЗнч(УстановленныйПакет.Значение) = Тип("Структура") Тогда
			ОписаниеПакета = УстановленныйПакет.Значение.МетаданныеПакета;
			Если ТипЗнч(ОписаниеПакета) = Тип("Булево") Тогда
				// @deprecated
			Иначе
				СтрокаСообщения = СтрокаСообщения + "@" + ОписаниеПакета.Свойства().Версия;
			КонецЕсли;		
		КонецЕсли;
		Сообщить(СтрокаСообщения);
	КонецЦикла;
	
КонецПроцедуры